//+------------------------------------------------------------------+
//|                                             id_digits_object.mq5 |
//|                                                2015, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.08"
#property description "When you click on a graphical object, this indicator"
#property description "shows in the tab of the trading terminal \"Experts\":"
#property description "- name and type the object;"
#property description "- time its anchor points;"
#property description "- the values of its anchor points;"
#property description "- the number of decimal digits in the anchor points."
#property indicator_chart_window
#property indicator_plots   0
//---
#define VALUES_TWO      (2)
#define VALUES_THREE    (3)
#define VALUES_FIVE     (5)
#define LINE_NUMBER     "Line: ",__LINE__,", "
//---
string textLng[6];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- ,      :
   LanguageTerminal();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)//id = 1
     {
      string clickedChartObject=sparam;
      //---  :
      ActionsDependingOnTheObjectType(clickedChartObject);
      return;
     }
   return;
  }
//+------------------------------------------------------------------+
//|  ,           |
//|:                                                        |
//+------------------------------------------------------------------+
void LanguageTerminal()
  {
   string language_t=NULL;
//---
   language_t=TerminalInfoString(TERMINAL_LANGUAGE);
//---
   if(language_t=="Russian")
     {
      textLng[0]=" : ";
      textLng[1]=", : ";
      textLng[2]="";
      textLng[3]="";
      textLng[4]=", digits: ";
      textLng[5]="      .";
     }
   else
     {
      textLng[0]="Object name: ";
      textLng[1]=", type: ";
      textLng[2]="Date";
      textLng[3]="Value";
      textLng[4]=", digits: ";
      textLng[5]="I don't work with this type of objects.";
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|    ,            |
//+------------------------------------------------------------------+
void ActionsDependingOnTheObjectType(const string name,// 
                                     const long chart_ID=0)
  {
   ENUM_OBJECT type=-1;
//---  
   type=(ENUM_OBJECT)ObjectGetInteger(chart_ID,name,OBJPROP_TYPE);
//---
   switch(type)
     {
      //--- :
      case OBJ_HLINE:GetValues1(chart_ID,name,type);break;//(1)
      //--- :
      case OBJ_TREND:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //---   :
      case OBJ_TRENDBYANGLE:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //--- :
      case OBJ_CYCLES:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //--- "  ":
      case OBJ_ARROWED_LINE:GetTime2Values2(chart_ID,name,type);break;//(2/2)    
      //--- :
      case OBJ_CHANNEL:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //--- :
      case OBJ_PITCHFORK:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //--- :
      case OBJ_GANNLINE:GetTime2Values1(chart_ID,name,type);break;//(2/1)
      //--- :
      case OBJ_GANNFAN:GetTime2Values1(chart_ID,name,type);break;//(2/1)
      //--- :
      case OBJ_GANNGRID:GetTime2Values1(chart_ID,name,type);break;//(2/1)
      //--- :
      case OBJ_FIBO:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //---  :
      case OBJ_FIBOTIMES:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //--- :
      case OBJ_FIBOFAN:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //--- :
      case OBJ_FIBOARC:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //--- :
      case OBJ_FIBOCHANNEL:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //--- :
      case OBJ_EXPANSION:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //---5-  (  ):
      case OBJ_ELLIOTWAVE5:GetTime5Values5(chart_ID,name,type);break;//(5/5)
      //---3-  (  ):
      case OBJ_ELLIOTWAVE3:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //---:
      case OBJ_RECTANGLE:GetTime2Values2(chart_ID,name,type);break;//(2/2)
      //---:
      case OBJ_TRIANGLE:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //---:
      case OBJ_ELLIPSE:GetTime3Values3(chart_ID,name,type);break;//(3/3)
      //--- "" (  ):
      case OBJ_ARROW_THUMB_UP:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "" (  ):
      case OBJ_ARROW_THUMB_DOWN:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- " ":
      case OBJ_ARROW_UP:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- " ":
      case OBJ_ARROW_DOWN:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "":
      case OBJ_ARROW_STOP:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "" ():
      case OBJ_ARROW_CHECK:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //---  :
      case OBJ_ARROW_LEFT_PRICE:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //---  :
      case OBJ_ARROW_RIGHT_PRICE:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "Buy":
      case OBJ_ARROW_BUY:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "Sell":
      case OBJ_ARROW_SELL:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "":
      case OBJ_ARROW:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //--- "":
      case OBJ_TEXT:GetTime1Values1(chart_ID,name,type);break;//(1/1)
      //---      :
      default:Print(LINE_NUMBER,textLng[5]);break;
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                    |
//|-    (   ),          |
//|             |
//|   :                                             |
//+------------------------------------------------------------------+
void GetValues1(const long chart_ID,     // ID 
                const string name,       //  
                const ENUM_OBJECT type)  //  
  {
   int digits=-1;
   double value=0.0;
//---   :
   value=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE);
//---    :
   digits=GetQuantDigits(value);
//---      ,  :
   if(digits==-1){return;}
//---
   string text[VALUES_TWO]={NULL,NULL};
//---
   StringConcatenate(text[1],textLng[3],": ",DoubleToString(value,digits),
                     textLng[4],digits);
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_TWO-1;i>=0;i--)
     {Print(text[i]);}
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                       |
//|-    ;                                    |
//|-    (   ),          |
//|           : |
//+------------------------------------------------------------------+
void GetTime2Values2(const long chart_ID,
                     const string name,
                     const ENUM_OBJECT type)
  {
   int digits[VALUES_TWO];
   double value[VALUES_TWO];
   datetime time[VALUES_TWO];
//---
   ArrayInitialize(digits,-1);
   ArrayInitialize(value,0.0);
   ArrayInitialize(time,0);
//---   :
   for(int i=VALUES_TWO-1;i>=0;i--)
     {value[i]=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE,i);}
//---    :
   for(int i=VALUES_TWO-1;i>=0;i--)
     {digits[i]=GetQuantDigits(value[i]);}
//---      ,  :
   for(int i=VALUES_TWO-1;i>=0;i--)
     {if(digits[i]==-1){return;}}
//---   :
   for(int i=VALUES_TWO-1;i>=0;i--)
     {time[i]=(datetime)ObjectGetInteger(chart_ID,name,OBJPROP_TIME,i);}
//---
   string text[VALUES_THREE]={NULL,NULL,NULL};
//---
   for(int i=VALUES_TWO;i>=1;i--)
     {
      StringConcatenate(text[i],textLng[2],"(",i-1,"): ",
                        TimeToString(time[i-1],TIME_DATE|TIME_SECONDS),". ",
                        textLng[3],"(",i-1,"): ",
                        DoubleToString(value[i-1],digits[i-1]),textLng[4],
                        digits[i-1]);
     }
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_TWO;i>=0;i--)
      Print(text[i]);
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                       |
//|-    ;                                    |
//|-    (   ),          |
//|           : |
//+------------------------------------------------------------------+
void GetTime3Values3(const long chart_ID,
                     const string name,
                     const ENUM_OBJECT type)
  {
   int digits[VALUES_THREE];
   double value[VALUES_THREE];
   datetime time[VALUES_THREE];
//---
   ArrayInitialize(digits,-1);
   ArrayInitialize(value,0.0);
   ArrayInitialize(time,0);
//---   :
   for(int i=VALUES_THREE-1;i>=0;i--)
     {value[i]=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE,i);}
//---    :
   for(int i=VALUES_THREE-1;i>=0;i--)
     {digits[i]=GetQuantDigits(value[i]);}
//---      ,  :
   for(int i=VALUES_THREE-1;i>=0;i--)
     {if(digits[i]==-1){return;}}
//---   :
   for(int i=VALUES_THREE-1;i>=0;i--)
     {time[i]=(datetime)ObjectGetInteger(chart_ID,name,OBJPROP_TIME,i);}
//---
   string text[VALUES_THREE+1]={NULL,NULL,NULL,NULL};
//---
   for(int i=VALUES_THREE;i>=1;i--)
     {
      StringConcatenate(text[i],textLng[2],"(",i-1,"): ",
                        TimeToString(time[i-1],TIME_DATE|TIME_SECONDS),". ",
                        textLng[3],"(",i-1,"): ",
                        DoubleToString(value[i-1],digits[i-1]),textLng[4],
                        digits[i-1]);
     }
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_THREE;i>=0;i--)
     {Print(text[i]);}
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                       |
//|-    ;                                    |
//|-    (   ),          |
//|               |
//| :                                                         |
//+------------------------------------------------------------------+
void GetTime2Values1(const long chart_ID,
                     const string name,
                     const ENUM_OBJECT type)
  {
   int digits=-1;
   double value=0.0;
   datetime time[VALUES_TWO];
//---
   ArrayInitialize(time,0);
//---   :
   value=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE);
//---    :
   digits=GetQuantDigits(value);
//---      ,  :
   if(digits==-1){return;}
//---   :
   for(int i=VALUES_TWO-1;i>=0;i--)
     {time[i]=(datetime)ObjectGetInteger(chart_ID,name,OBJPROP_TIME,i);}
//---
   string text[VALUES_THREE]={NULL,NULL,NULL};
//---
   StringConcatenate(text[2],textLng[2],"(1): ",
                     TimeToString(time[1],TIME_DATE|TIME_SECONDS));
   StringConcatenate(text[1],textLng[2],"(0): ",
                     TimeToString(time[0],TIME_DATE|TIME_SECONDS),". ",
                     textLng[3],": ",DoubleToString(value,digits),
                     textLng[4],digits);
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_TWO;i>=0;i--)
     {Print(text[i]);}
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                       |
//|-    ;                                    |
//|-    (   ),          |
//|           :|
//+------------------------------------------------------------------+
void GetTime5Values5(const long chart_ID,
                     const string name,
                     const ENUM_OBJECT type)
  {
   int digits[VALUES_FIVE];
   double value[VALUES_FIVE];
   datetime time[VALUES_FIVE];
//---
   ArrayInitialize(digits,-1);
   ArrayInitialize(value,0.0);
   ArrayInitialize(time,0);
//---   :
   for(int i=VALUES_FIVE-1;i>=0;i--)
     {value[i]=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE,i);}
//---    :
   for(int i=VALUES_FIVE-1;i>=0;i--)
     {digits[i]=GetQuantDigits(value[i]);}
//---      ,  :
   for(int i=VALUES_FIVE-1;i>=0;i--)
     {if(digits[i]==-1){return;}}
//---   :
   for(int i=VALUES_FIVE-1;i>=0;i--)
     {time[i]=(datetime)ObjectGetInteger(chart_ID,name,OBJPROP_TIME,i);}
//---
   string text[VALUES_FIVE+1]={NULL,NULL,NULL,NULL,NULL,NULL};
//---
   for(int i=VALUES_FIVE;i>=1;i--)
     {
      StringConcatenate(text[i],textLng[2],"(",i-1,"): ",
                        TimeToString(time[i-1],TIME_DATE|TIME_SECONDS),". ",
                        textLng[3],"(",i-1,"): ",
                        DoubleToString(value[i-1],digits[i-1]),textLng[4],
                        digits[i-1]);
     }
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_FIVE;i>=0;i--)
     {Print(text[i]);}
//---
   return;
  }
//+------------------------------------------------------------------+
//|      "":                   |
//|-  ;                                                    |
//|-  ;                                                    |
//|-    ;                                       |
//|-    ;                                    |
//|-    (   ),          |
//|              |
//| :                                                         |
//+------------------------------------------------------------------+
void GetTime1Values1(const long chart_ID,
                     const string name,
                     const ENUM_OBJECT type)
  {
   int digits=-1;
   double value=0.0;
   datetime time=0;
//---   :
   value=ObjectGetDouble(chart_ID,name,OBJPROP_PRICE);
//---    :
   digits=GetQuantDigits(value);
//---      ,  :
   if(digits==-1){return;}
//---   :
   time=(datetime)ObjectGetInteger(chart_ID,name,OBJPROP_TIME);
//---
   string text[VALUES_TWO]={NULL,NULL};
//---
   StringConcatenate(text[1],textLng[2],": ",
                     TimeToString(time,TIME_DATE|TIME_SECONDS),". ",
                     textLng[3],": ",DoubleToString(value,digits),
                     textLng[4],digits);
   StringConcatenate(text[0],textLng[0],name,textLng[1],EnumToString(type));
//---
   for(int i=VALUES_TWO-1;i>=0;i--)
     {Print(text[i]);}
  }
//+------------------------------------------------------------------+
//|GetQuantDigits -       |
//|(  )                                    |
//+------------------------------------------------------------------+
//|2015, Dina Paches (  25.09.2015)                |
//|dipaches.blogspot.com                                             |
//|https://login.mql5.com/ru/users/dipach                            |
//+------------------------------------------------------------------+
int GetQuantDigits(const double val,//  double
                   const int digits=8)
  {
   int res=digits;
   if(res<1 || res>8)
     {
      Print(__LINE__,__FUNCTION__," Error code. digits <1 or >8.");
      res=-1;
      return(res);
     }
//---  = 0,  
   if(NormalizeDouble(val,digits)==0)
     {
      res=0;
      return(res);
     }
//---
   double val_abs=val;
   double val_floor=0;
//---  < 0,     
   if(NormalizeDouble(val_abs,digits)<0)
     {val_abs=MathAbs(val_abs);}
//---    
   val_floor=MathFloor(val_abs);
//---      
   val_abs=NormalizeDouble(val_abs-val_floor,digits);
//---    ,  
   if(NormalizeDouble(val_abs,digits)==0)
     {
      res=0;
      return(res);
     }
//---  ,     0   .
//---       
   int val_pow=(int)MathPow(10,digits);
   int val_res_dig=(int)(NormalizeDouble(val_abs*val_pow,0));
//---       
   string text=IntegerToString(val_res_dig);
//---   
   int lengh=StringLen(text);
//---   
   for(int i=lengh-1;i>=0;i--)
     {
      if(StringFind(text,"0",i)==i)
        {res=res-1;}
      else {return(res);}
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
